#include <mutex>
#include "rclcpp/rclcpp.hpp"
#include "std_msgs/msg/string.hpp"
#include "std_srvs/srv/empty.hpp"
#include "{{ pkgname }}/srv/state.hpp"
#include "{{ pkgname }}/srv/transition.hpp"

class {{ skillset|capitalize }}ResourceManager : public rclcpp::Node {
private:
  // Mutex
  std::mutex mutex_;
  rclcpp::Service<std_srvs::srv::Empty>::SharedPtr mutex_lock_srv_;
  rclcpp::Service<std_srvs::srv::Empty>::SharedPtr mutex_unlock_srv_;
  rclcpp::CallbackGroup::CallbackGroup::SharedPtr mutex_group_;
  // Resources
  std_msgs::msg::String state_msg;
  {% for res in resources %}
  std::string {{ res.name }}_state_;
  rclcpp::Service<{{ pkgname }}::srv::State>::SharedPtr {{ res.name }}_get_srv_;
  rclcpp::Service<{{ pkgname }}::srv::Transition>::SharedPtr {{ res.name }}_change_srv_;
  rclcpp::Service<{{ pkgname }}::srv::Transition>::SharedPtr {{ res.name }}_change_internal_srv_;
  rclcpp::Publisher<std_msgs::msg::String>::SharedPtr {{ res.name }}_state_publisher_;
  {% endfor %}

  {% for res in resources %}
  bool {{ res.name }}_transition_exists(std::string target, bool use_extern) {
    (void)use_extern; // remove unused warning
    {%- for arc in res.statemachine.arcs %}
    if (this->{{ res.name }}_state_ == "{{ arc.src }}" && target == "{{ arc.dst }}")
      return {% if arc.extern %}use_extern{% else %}true{% endif %};
    {%- endfor %}
    return false;
  };

  bool {{ res.name }}_transition(std::string target, bool use_extern)
  {
    RCLCPP_INFO(this->get_logger(), "received change request on {{ res.name }} to %s", target.c_str());
    if (this->{{ res.name }}_transition_exists(target, use_extern)) {
      this->{{ res.name }}_state_ = target;
      this->state_msg.data = this->{{ res.name }}_state_;
      this->{{ res.name }}_state_publisher_->publish(this->state_msg);
      return true;
    }
    else {
      return false;
    }
  }

  void change_{{ res.name }}_state(const std::shared_ptr<{{ pkgname }}::srv::Transition::Request> request,
    std::shared_ptr<{{ pkgname }}::srv::Transition::Response> response)
  {
    this->mutex_.lock();
    response->success = this->{{ res.name }}_transition(request->target, true);
    response->state = this->{{ res.name }}_state_;
    this->mutex_.unlock();
  }

  void change_{{ res.name }}_internal_state(const std::shared_ptr<{{ pkgname }}::srv::Transition::Request> request,
    std::shared_ptr<{{ pkgname }}::srv::Transition::Response> response)
  {
    response->success = this->{{ res.name }}_transition(request->target, false);
    response->state = this->{{ res.name }}_state_;
  }

  void get_{{ res.name }}_state(const std::shared_ptr<{{ pkgname }}::srv::State::Request> request,
    std::shared_ptr<{{ pkgname }}::srv::State::Response> response)
  {
    RCLCPP_DEBUG(this->get_logger(), "get_state of {{ res.name }}: %s", this->{{ res.name }}_state_.c_str());
    (void)request; // Remove 'unused parameter' warning
    response->state = this->{{ res.name }}_state_;
  }
  {% endfor %}

  void mutex_lock(const std::shared_ptr<std_srvs::srv::Empty::Request> request,
    std::shared_ptr<std_srvs::srv::Empty::Response> response)
  {
    RCLCPP_INFO(this->get_logger(), "lock resource manager");
    (void)request; (void)response; // Remove 'unused parameter' warning
    this->mutex_.lock();
    RCLCPP_INFO(this->get_logger(), "resource manager locked");
  }

  void mutex_unlock(const std::shared_ptr<std_srvs::srv::Empty::Request> request,
    std::shared_ptr<std_srvs::srv::Empty::Response> response)
  {
    RCLCPP_INFO(this->get_logger(), "unlock resource manager");
    (void)request; (void)response; // Remove 'unused parameter' warning
    this->mutex_.unlock();
  }

public:
  explicit {{ skillset|capitalize }}ResourceManager()
    : rclcpp::Node("resource_manager")
  {
    using namespace std::placeholders;
    this->mutex_group_ = this->create_callback_group(rclcpp::CallbackGroupType::Reentrant);
    this->mutex_lock_srv_ = this->create_service<std_srvs::srv::Empty>("resource/internal/lock",
      std::bind(&{{ skillset|capitalize }}ResourceManager::mutex_lock, this, _1, _2),
      rmw_qos_profile_services_default, this->mutex_group_);
    this->mutex_unlock_srv_ = this->create_service<std_srvs::srv::Empty>("resource/internal/unlock",
      std::bind(&{{ skillset|capitalize }}ResourceManager::mutex_unlock, this, _1, _2),
      rmw_qos_profile_services_default, this->mutex_group_);
    
    {% for res in resources %}
    this->{{ res.name }}_state_publisher_ = this->create_publisher<std_msgs::msg::String>("resource/{{ res.name }}_state", 1);
    this->{{ res.name }}_get_srv_ = this->create_service<{{ pkgname }}::srv::State>("resource/get_{{ res.name }}",
      std::bind(&{{ skillset|capitalize }}ResourceManager::get_{{ res.name }}_state, this, _1, _2));
    this->{{ res.name }}_change_srv_ = this->create_service<{{ pkgname }}::srv::Transition>("resource/change_{{ res.name }}",
      std::bind(&{{ skillset|capitalize }}ResourceManager::change_{{ res.name }}_state, this, _1, _2));
    this->{{ res.name }}_change_internal_srv_ = this->create_service<{{ pkgname }}::srv::Transition>("resource/internal/change_{{ res.name }}",
      std::bind(&{{ skillset|capitalize }}ResourceManager::change_{{ res.name }}_internal_state, this, _1, _2));

    this->{{ res.name }}_state_ = this->declare_parameter<std::string>("{{ res.name }}_initial", "{{ res.statemachine.initial }}");
    RCLCPP_INFO(this->get_logger(), "Initialize resource {{ res.name }} in state %s", this->{{res.name}}_state_.c_str());
    {% endfor %}
    RCLCPP_INFO(this->get_logger(), "Resource Manager ready");
  }

};

int main(int argc, char **argv)
{
  rclcpp::init(argc, argv);
  auto rm = std::make_shared<{{ skillset|capitalize }}ResourceManager>();
  rm->declare_parameter("spinner_threads", {{ number_skills }}+2);
  auto spinner_threads = rm->get_parameter("spinner_threads").as_int();
  RCLCPP_INFO(rm->get_logger(), "start manager with %ld threads", spinner_threads);
  rclcpp::executors::MultiThreadedExecutor executor(rclcpp::ExecutorOptions(), spinner_threads);
  executor.add_node(rm);
  executor.spin();
  rclcpp::shutdown();
  return 0;
}
